/*
 * Work under Copyright. Licensed under the EUPL.
 * See the project README.md and LICENSE.txt for more information.
 */

package net.dries007.tfc.client.button;

import javax.annotation.Nonnull;

import net.minecraft.client.Minecraft;
import net.minecraft.client.renderer.GlStateManager;

import net.dries007.tfc.objects.te.TELargeVessel;

import static net.dries007.tfc.api.util.TFCConstants.MOD_ID;
import static net.dries007.tfc.client.gui.GuiLargeVessel.LARGE_VESSEL_BACKGROUND;


public class GuiButtonLargeVesselSeal extends GuiButtonTFC implements IButtonTooltip
{
    private final TELargeVessel tile;

    public GuiButtonLargeVesselSeal(TELargeVessel tile, int buttonId, int guiTop, int guiLeft)
    {
        super(buttonId, guiLeft + 123, guiTop + 35, 20, 20, "");
        this.tile = tile;
    }

    @Override
    public String getTooltip()
    {
        return MOD_ID + ".tooltip." + (tile.isSealed() ? "large_vessel_unseal" : "large_vessel_seal");
    }

    @Override
    public boolean hasTooltip()
    {
        return true;
    }

    @Override
    public void func_191745_a(@Nonnull Minecraft mc, int mouseX, int mouseY, float partialTicks)
    {
        if (this.field_146125_m)
        {
            GlStateManager.func_179131_c(1, 1, 1, 1);
            mc.func_110434_K().func_110577_a(LARGE_VESSEL_BACKGROUND);
            field_146123_n = mouseX >= this.field_146128_h && mouseY >= this.field_146129_i && mouseX < this.field_146128_h + this.field_146120_f && mouseY < this.field_146129_i + this.field_146121_g;
            if (tile.isSealed())
            {
                func_146110_a(field_146128_h, field_146129_i, 236, 0, 20, 20, 256, 256);
            }
            else
            {
                func_146110_a(field_146128_h, field_146129_i, 236, 20, 20, 20, 256, 256);
            }
            func_146119_b(mc, mouseX, mouseY);
        }
    }
}
