/*
 * Work under Copyright. Licensed under the EUPL.
 * See the project README.md and LICENSE.txt for more information.
 */

package net.dries007.tfc.client.gui;

import net.minecraft.client.gui.GuiButton;
import net.minecraft.client.gui.inventory.GuiInventory;
import net.minecraft.client.resources.I18n;
import net.minecraft.entity.player.InventoryPlayer;
import net.minecraft.inventory.Container;
import net.minecraft.util.ResourceLocation;
import net.minecraft.util.text.TextFormatting;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

import net.dries007.tfc.TerraFirmaCraft;
import net.dries007.tfc.client.TFCGuiHandler;
import net.dries007.tfc.client.button.GuiButtonPlayerInventoryTab;
import net.dries007.tfc.network.PacketSwitchPlayerInventoryTab;
import net.dries007.tfc.util.calendar.CalendarTFC;

import static net.dries007.tfc.api.util.TFCConstants.MOD_ID;

@SideOnly(Side.CLIENT)
public class GuiCalendar extends GuiContainerTFC
{
    private static final ResourceLocation BACKGROUND = new ResourceLocation(MOD_ID, "textures/gui/player_calendar.png");

    public GuiCalendar(Container container, InventoryPlayer playerInv)
    {
        super(container, playerInv, BACKGROUND);
    }

    @Override
    public void func_73866_w_()
    {
        super.func_73866_w_();

        int buttonId = 0;
        func_189646_b(new GuiButtonPlayerInventoryTab(TFCGuiHandler.Type.INVENTORY, field_147003_i, field_147009_r, ++buttonId, true));
        func_189646_b(new GuiButtonPlayerInventoryTab(TFCGuiHandler.Type.SKILLS, field_147003_i, field_147009_r, ++buttonId, true));
        func_189646_b(new GuiButtonPlayerInventoryTab(TFCGuiHandler.Type.CALENDAR, field_147003_i, field_147009_r, ++buttonId, false));
        func_189646_b(new GuiButtonPlayerInventoryTab(TFCGuiHandler.Type.NUTRITION, field_147003_i, field_147009_r, ++buttonId, true));
    }

    @Override
    protected void func_146979_b(int mouseX, int mouseY)
    {
        super.func_146979_b(mouseX, mouseY);

        String tooltip = TextFormatting.WHITE + "" + TextFormatting.UNDERLINE + I18n.func_135052_a("tfc.tooltip.calendar") + ":";
        field_146289_q.func_78276_b(tooltip, field_146999_f / 2 - field_146289_q.func_78256_a(tooltip) / 2, 7, 0x404040);

        String season, day, date;

        season = I18n.func_135052_a("tfc.tooltip.season", CalendarTFC.CALENDAR_TIME.getSeasonDisplayName());
        day = I18n.func_135052_a("tfc.tooltip.day", CalendarTFC.CALENDAR_TIME.getDisplayDayName());
        date = I18n.func_135052_a("tfc.tooltip.date", CalendarTFC.CALENDAR_TIME.getTimeAndDate());

        field_146289_q.func_78276_b(season, field_146999_f / 2 - field_146289_q.func_78256_a(season) / 2, 25, 0x404040);
        field_146289_q.func_78276_b(day, field_146999_f / 2 - field_146289_q.func_78256_a(day) / 2, 34, 0x404040);
        field_146289_q.func_78276_b(date, field_146999_f / 2 - field_146289_q.func_78256_a(date) / 2, 43, 0x404040);
    }

    @Override
    protected void func_146284_a(GuiButton button)
    {
        if (button instanceof GuiButtonPlayerInventoryTab && ((GuiButtonPlayerInventoryTab) button).isActive())
        {
            GuiButtonPlayerInventoryTab tabButton = (GuiButtonPlayerInventoryTab) button;
            if (tabButton.isActive())
            {
                if (tabButton.getGuiType() == TFCGuiHandler.Type.INVENTORY)
                {
                    this.field_146297_k.func_147108_a(new GuiInventory(playerInv.field_70458_d));
                }
                TerraFirmaCraft.getNetwork().sendToServer(new PacketSwitchPlayerInventoryTab(tabButton.getGuiType()));
            }
        }
    }
}
