/*
 * Work under Copyright. Licensed under the EUPL.
 * See the project README.md and LICENSE.txt for more information.
 */

package net.dries007.tfc.client.model.animal;

import javax.annotation.Nonnull;
import javax.annotation.ParametersAreNonnullByDefault;

import net.minecraft.client.model.ModelQuadruped;
import net.minecraft.client.model.ModelRenderer;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.entity.Entity;
import net.minecraft.util.math.MathHelper;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

import net.dries007.tfc.objects.entity.animal.EntityAnimalTFC;
import net.dries007.tfc.objects.entity.animal.EntityPigTFC;

@SideOnly(Side.CLIENT)
@ParametersAreNonnullByDefault
public class ModelPigTFC extends ModelQuadruped
{
    private ModelRenderer tusk1;
    private ModelRenderer tusk2;
    private ModelRenderer snout;

    public ModelPigTFC()
    {
        super(6, 0);
        this.field_78150_a.func_78784_a(16, 16).func_78790_a(-2.0F, 0.0F, -9.0F, 4, 3, 1, 0);
        this.field_78145_g = 4.0F;
        tusk1 = new ModelRenderer(this, 32, 0);
        tusk1.func_78790_a(0F, 0F, 0F, 1, 2, 1, 0F);
        tusk1.func_78793_a(-3f, 0.5f, -9f);
        tusk1.field_78795_f = (float) Math.PI / 12;

        tusk2 = new ModelRenderer(this, 32, 0);
        tusk2.func_78790_a(0F, 0F, 0F, 1, 2, 1, 0F);
        tusk2.func_78793_a(2f, 0.5f, -9f);
        tusk2.field_78795_f = (float) Math.PI / 12;

        snout = new ModelRenderer(this, 0, 26);
        snout.func_78790_a(-2.0F, 0.0F, -10.0F, 4, 3, 3, 0);
        snout.func_78792_a(tusk1);
        snout.func_78792_a(tusk2);
        this.field_78150_a.func_78792_a(snout);
    }

    @Override
    public void func_78088_a(@Nonnull Entity entity, float par2, float par3, float par4, float par5, float par6, float par7)
    {
        EntityPigTFC pig = ((EntityPigTFC) entity);

        float percent = pig.getPercentToAdulthood();
        float ageScale = 2.0F - percent;
        float ageHeadScale = (float) Math.pow(1 / ageScale, 0.66);

        this.func_78087_a(par2, par3, par4, par5, par6, par7, entity);
        if (pig.getGender() == EntityAnimalTFC.Gender.MALE)
        {
            if (!pig.func_70631_g_())
            {
                tusk1.field_78807_k = false;
                tusk2.field_78807_k = false;
            }
        }

        GlStateManager.func_179094_E();

        GlStateManager.func_179109_b(0.0F, 0.75f - (0.75f * percent), 0f);
        GlStateManager.func_179152_a(ageHeadScale, ageHeadScale, ageHeadScale);
        GlStateManager.func_179109_b(0.0F, (ageScale - 1) * -0.125f, 0.1875f - (0.1875f * percent));
        field_78150_a.func_78785_a(par7);
        GlStateManager.func_179121_F();

        GlStateManager.func_179094_E();
        GlStateManager.func_179109_b(0.0F, 0.75f - (0.75f * percent), 0f);
        GlStateManager.func_179152_a(1 / ageScale, 1 / ageScale, 1 / ageScale);

        field_78148_b.func_78785_a(par7);
        field_78149_c.func_78785_a(par7);
        field_78146_d.func_78785_a(par7);
        field_78147_e.func_78785_a(par7);
        field_78144_f.func_78785_a(par7);
        GlStateManager.func_179121_F();
    }

    @Override
    public void func_78087_a(float par1, float par2, float par3, float par4, float par5, float par6, Entity par7Entity)
    {
        tusk1.field_78807_k = true;
        tusk2.field_78807_k = true;
        this.field_78150_a.field_78795_f = par5 / (180F / (float) Math.PI);
        this.field_78150_a.field_78796_g = par4 / (180F / (float) Math.PI);
        this.field_78148_b.field_78795_f = (float) Math.PI / 2F;
        this.field_78149_c.field_78795_f = MathHelper.func_76134_b(par1 * 0.6662F) * 1.4F * par2;
        this.field_78146_d.field_78795_f = MathHelper.func_76134_b(par1 * 0.6662F + (float) Math.PI) * 1.4F * par2;
        this.field_78147_e.field_78795_f = MathHelper.func_76134_b(par1 * 0.6662F + (float) Math.PI) * 1.4F * par2;
        this.field_78144_f.field_78795_f = MathHelper.func_76134_b(par1 * 0.6662F) * 1.4F * par2;
    }
}
