/*
 * Work under Copyright. Licensed under the EUPL.
 * See the project README.md and LICENSE.txt for more information.
 */

package net.dries007.tfc.client.render;

import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.client.renderer.tileentity.TileEntitySpecialRenderer;
import net.minecraft.util.ResourceLocation;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

import net.dries007.tfc.api.types.Metal;
import net.dries007.tfc.client.model.ModelIngotPile;
import net.dries007.tfc.objects.te.TEIngotPile;

import static net.dries007.tfc.api.util.TFCConstants.MOD_ID;

@SideOnly(Side.CLIENT)
public class TESRIngotPile extends TileEntitySpecialRenderer<TEIngotPile>
{
    private final ModelIngotPile model = new ModelIngotPile();

    @Override
    public void func_192841_a(TEIngotPile te, double x, double y, double z, float partialTicks, int destroyStage, float alpha)
    {
        try
        {
            GlStateManager.func_179131_c(1, 1, 1, 1);

            Metal metal = te.getMetal();
            int count = te.getCount();
            //noinspection ConstantConditions
            func_147499_a(new ResourceLocation(MOD_ID, "textures/blocks/metal/" + metal.getRegistryName().func_110623_a() + ".png"));
            GlStateManager.func_179094_E();
            GlStateManager.func_179137_b(x, y, z);

            // Render Ingot Pile here
            model.renderIngots(count);
        }
        finally
        {
            GlStateManager.func_179121_F();
        }
    }
}
