/*
 * Work under Copyright. Licensed under the EUPL.
 * See the project README.md and LICENSE.txt for more information.
 */

package net.dries007.tfc.client.render.animal;

import javax.annotation.Nonnull;
import javax.annotation.ParametersAreNonnullByDefault;

import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.client.renderer.entity.RenderLiving;
import net.minecraft.client.renderer.entity.RenderManager;
import net.minecraft.util.ResourceLocation;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

import net.dries007.tfc.client.model.animal.ModelBearTFC;
import net.dries007.tfc.objects.entity.animal.EntityBearTFC;

import static net.dries007.tfc.api.util.TFCConstants.MOD_ID;

@SideOnly(Side.CLIENT)
@ParametersAreNonnullByDefault
public class RenderBearTFC extends RenderLiving<EntityBearTFC>
{
    private static final ResourceLocation TEXTURE = new ResourceLocation(MOD_ID, "textures/entity/animal/bear.png");

    public RenderBearTFC(RenderManager renderManager)
    {
        super(renderManager, new ModelBearTFC(), 0.7F);
    }

    @Override
    public void func_76986_a(@Nonnull EntityBearTFC bear, double par2, double par4, double par6, float par8, float par9)
    {
        this.field_76989_e = 0.35f + (bear.getPercentToAdulthood() * 0.35f);
        super.func_76986_a(bear, par2, par4, par6, par8, par9);
    }

    @Override
    protected float func_77044_a(EntityBearTFC par1EntityLiving, float par2)
    {
        return 1.0f;
    }

    @Override
    protected void func_77041_b(EntityBearTFC bear, float par2)
    {
        GlStateManager.func_179152_a(1.3f, 1.3f, 1.3f);
    }

    @Override
    protected ResourceLocation func_110775_a(EntityBearTFC entity)
    {
        return TEXTURE;
    }
}
