/*
 * Work under Copyright. Licensed under the EUPL.
 * See the project README.md and LICENSE.txt for more information.
 */

package net.dries007.tfc.client.render.animal;

import javax.annotation.ParametersAreNonnullByDefault;

import net.minecraft.client.renderer.entity.RenderLiving;
import net.minecraft.client.renderer.entity.RenderManager;
import net.minecraft.util.ResourceLocation;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

import net.dries007.tfc.client.model.animal.ModelDeerTFC;
import net.dries007.tfc.objects.entity.animal.EntityDeerTFC;

import static net.dries007.tfc.api.util.TFCConstants.MOD_ID;

@SideOnly(Side.CLIENT)
@ParametersAreNonnullByDefault
public class RenderDeerTFC extends RenderLiving<EntityDeerTFC>
{
    private static final ResourceLocation DEER_TEXTURE = new ResourceLocation(MOD_ID, "textures/entity/animal/deer.png");
    private static final ResourceLocation FAWN_TEXTURE = new ResourceLocation(MOD_ID, "textures/entity/animal/deer_fawn.png");

    public RenderDeerTFC(RenderManager manager)
    {
        super(manager, new ModelDeerTFC(), 0.7F);
    }

    @Override
    protected ResourceLocation func_110775_a(EntityDeerTFC deer)
    {
        if (deer.func_70631_g_())
        {
            return FAWN_TEXTURE;
        }
        else
        {
            return DEER_TEXTURE;
        }
    }

    @Override
    protected float func_77044_a(EntityDeerTFC deer, float par2)
    {
        return 1.0f;
    }
}
