/*
 * Work under Copyright. Licensed under the EUPL.
 * See the project README.md and LICENSE.txt for more information.
 */

package net.dries007.tfc.objects.items;

import javax.annotation.Nonnull;

import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemStack;
import net.minecraft.util.ActionResult;
import net.minecraft.util.EnumActionResult;
import net.minecraft.util.EnumHand;
import net.minecraft.world.World;

import net.dries007.tfc.api.capability.size.Size;
import net.dries007.tfc.api.capability.size.Weight;
import net.dries007.tfc.client.TFCGuiHandler;

public class ItemFireClay extends ItemTFC
{
    @Nonnull
    @Override
    public Size getSize(@Nonnull ItemStack stack)
    {
        return Size.VERY_SMALL;
    }

    @Nonnull
    @Override
    public Weight getWeight(@Nonnull ItemStack stack)
    {
        return Weight.MEDIUM;
    }

    @Override
    @Nonnull
    public ActionResult<ItemStack> func_77659_a(World world, EntityPlayer player, @Nonnull EnumHand hand)
    {
        ItemStack stack = player.func_184586_b(hand);
        if (!world.field_72995_K && !player.func_70093_af() && stack.func_190916_E() >= 5)
        {
            TFCGuiHandler.openGui(world, player.func_180425_c(), player, TFCGuiHandler.Type.KNAPPING_FIRE_CLAY);
        }
        return new ActionResult<>(EnumActionResult.SUCCESS, stack);
    }
}
