/*
 * Work under Copyright. Licensed under the EUPL.
 * See the project README.md and LICENSE.txt for more information.
 */

package net.dries007.tfc.objects.te;

import javax.annotation.Nonnull;

import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.tileentity.TileEntity;

import net.dries007.tfc.ConfigTFC;
import net.dries007.tfc.util.calendar.CalendarTFC;

import static net.dries007.tfc.objects.blocks.property.ILightableBlock.LIT;

public class TETorchTFC extends TileEntity
{
    private long lastLitTimestamp;

    public TETorchTFC()
    {
        lastLitTimestamp = CalendarTFC.PLAYER_TIME.getTicks();
    }

    public void onRandomTick()
    {
        if (CalendarTFC.PLAYER_TIME.getTicks() - lastLitTimestamp > (long) ConfigTFC.GENERAL.torchTime && ConfigTFC.GENERAL.torchTime > 0)
        {
            extinguish();
        }
    }

    @Override
    public void func_145839_a(NBTTagCompound compound)
    {
        lastLitTimestamp = compound.func_74763_f("ticks");
        super.func_145839_a(compound);
    }

    @Override
    @Nonnull
    public NBTTagCompound func_189515_b(NBTTagCompound compound)
    {
        compound.func_74772_a("ticks", lastLitTimestamp);
        return super.func_189515_b(compound);
    }

    public void extinguish()
    {
        field_145850_b.func_175656_a(field_174879_c, field_145850_b.func_180495_p(field_174879_c).func_177226_a(LIT, false));
        this.func_70296_d();
    }

    public void light()
    {
        field_145850_b.func_175656_a(field_174879_c, field_145850_b.func_180495_p(field_174879_c).func_177226_a(LIT, true));
        lastLitTimestamp = CalendarTFC.PLAYER_TIME.getTicks();
        this.func_70296_d();
    }
}
